Bug 215509 - Recommended parameters for HP StorageWork Arrays in built-in hwtable (Multipath tools)
Summary: Recommended parameters for HP StorageWork Arrays in built-in hwtable (Multipa...
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: device-mapper-multipath
Version: 4.4
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
: ---
Assignee: Ben Marzinski
QA Contact: Corey Marthaler
URL:
Whiteboard:
Keywords:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2006-11-14 13:51 UTC by Stephen Reilly
Modified: 2010-01-12 02:27 UTC (History)
12 users (show)

(edit)
Clone Of:
(edit)
Last Closed: 2007-05-01 17:46:43 UTC


Attachments (Terms of Use)
Updates to multipath.conf.defaults (4.84 KB, patch)
2006-11-16 15:31 UTC, Dave Wysochanski
no flags Details | Diff
modify store_hwe_ext to include no_path_retry and rr_weight variables (4.63 KB, patch)
2006-11-22 21:24 UTC, Dave Wysochanski
no flags Details | Diff
Add abillity to set rr_min_io from hwtable.c (9.50 KB, patch)
2006-11-22 21:31 UTC, Dave Wysochanski
no flags Details | Diff


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Product Errata RHEA-2007:0256 normal SHIPPED_LIVE device-mapper-multipath enhancement update 2007-05-01 17:35:42 UTC

Description Stephen Reilly 2006-11-14 13:51:32 UTC
Description of problem:

The Default Entries for the HP Storageworks Arrays in hw-table.c needs to be 
modified to suit the HP Arrays. 
HP Recommends the following multipath device attributes in built-in hwtable 
and as well as in multipath.conf file.

Please modify the built-in hwtable entries and multipath.conf attributes for 
HP Arrays wherever its applicable.

For EVA3000-(HSV101):

device {
vendor                 "HP"
product                "HSV101 \(C\)COMPAQ"
path_grouping_policy   group_by_prio
getuid_callout         "/sbin/scsi_id -g -u -s /block/%n"
path_checker           tur
path_selector          "round-robin 0"
prio_callout           "/sbin/mpath_prio_alua %n"
rr_weight              uniform
rr_min_io              100
failback               immediate
no_path_retry          60
}

For EVA5000-(HSV111):

device {
vendor                 "COMPAQ"
product                "HSV111 \(C\)COMPAQ"
path_grouping_policy   group_by_prio
getuid_callout         "/sbin/scsi_id -g -u -s /block/%n"
path_checker           tur
path_selector          "round-robin 0"
prio_callout           "/sbin/mpath_prio_alua %n"
rr_weight              uniform
rr_min_io              100
failback               immediate
no_path_retry          60
}

For EVA4000/6000:

device {
vendor                 "HP"
product                "HSV200"
path_grouping_policy   group_by_prio
getuid_callout         "/sbin/scsi_id -g -u -s /block/%n"
path_checker           tur
path_selector          "round-robin 0"
prio_callout           "/sbin/mpath_prio_alua %n"
rr_weight              uniform
rr_min_io              100
failback               immediate
no_path_retry          60
}

For EVA8000:

device {
vendor                "HPā€
product               "HSV210"
path_grouping_policy  group_by_prio
getuid_callout        "/sbin/scsi_id -g -u -s /block/%n"
path_checker          tur
path_selector         "round-robin 0"
prio_callout          "/sbin/mpath_prio_alua %n"
rr_weight             uniform
rr_min_io             100
failback              immediate
no_path_retry         60
}

For XP arrays:

device {
vendor                "HP"
product               "OPEN-*"
path_grouping_policy  multibus
rr_weight             uniform
rr_min_io             100
path_checker          tur
failback              immediate
}

Please let us know if you need any information on this.

Thanks

Comment 1 Dave Wysochanski 2006-11-14 14:30:47 UTC
Thanks for the info Steve.  I will take this one.

Comment 2 Dave Wysochanski 2006-11-16 15:24:07 UTC
Working on this now and will attach patch against multipath-tools-0.4.5.61
(rhel4 u4 device-mapper-multipath src tarball).

Comment 3 Dave Wysochanski 2006-11-16 15:31:54 UTC
Created attachment 141376 [details]
Updates to multipath.conf.defaults

Comment 4 Dave Wysochanski 2006-11-16 16:45:04 UTC
Doing hwtable.c now.  Looks like we can't currently set no_path_retry there, but
probably a small patch will allow us to do it.  Upstream is a bit different in
this area.

Comment 5 Stephen Reilly 2006-11-16 21:40:07 UTC
I am curious why you can't make the change given that no_path_retry was 
introduced in RH4.4?

Comment 6 Dave Wysochanski 2006-11-16 22:19:48 UTC
It's just a problem with how hwtable.c was written - RHEL4 still has the older
code and only certain params could be set as defaults for each controller.  The
fact that no_path_retry will work from /etc/multipath.conf is a different issue
altogether than setting the default params in hwtable.c

Comment 7 Dave Wysochanski 2006-11-22 21:21:15 UTC
Looks like the hwtable.c code doesn't handle 3 param's:
1) no_path_retry
2) rr_weight
3) rr_min_io

The first 2 are fairly easy but the 3rd one is a little tricker.  Since we are
so far along in RHEL4, I will break up the patches and let Ben review/decide.



Comment 8 Dave Wysochanski 2006-11-22 21:24:42 UTC
Created attachment 141943 [details]
modify store_hwe_ext to include no_path_retry and rr_weight variables

Should apply cleanly to latest cvs for RHEL4/FC5.

Comment 9 Dave Wysochanski 2006-11-22 21:31:55 UTC
Created attachment 141944 [details]
Add abillity to set rr_min_io from hwtable.c

Patch should apply on top of previous patch, add-new-hwe-interface.patch,
attachment #141943 [details].  This one is a bit more involved.

Comment 10 Stephen Reilly 2006-11-24 04:34:41 UTC
Thanks for the fix. 
please communicate us the following things like,
1. when these changes will be integrated into the distribution?
2. Will it be released as separate multipath-tools RPM ?
3. If so, when can we expect that?




Comment 11 Ben Marzinski 2006-11-27 20:20:47 UTC
Both patches look good.  I'm going to do a little bit of testing, and then I'll
commit these shortly.  I'll respin the RPM after I get a few more of the RHEL
4.5 fixes in. These fixes will integrated into RHEL 4.5 unless there is an
official hotfix request.

Comment 12 Dave Wysochanski 2006-11-27 21:11:09 UTC
Ben are you going to handle the actual HP specific settings in this bz or do you
want me to make a patch over the other ones?

Thanks.

Comment 13 Ben Marzinski 2006-11-27 22:38:09 UTC
I can change the HP controller settings.

Comment 14 Ben Marzinski 2006-12-04 16:19:22 UTC
The controller setting have been changed

Comment 18 Ben Levenson 2007-04-11 04:37:09 UTC
This fix is in the latest snapshot.  Please retest with the latest packages:
device-mapper-multipath-0.4.5-21.RHEL4



Comment 20 Red Hat Bugzilla 2007-05-01 17:46:44 UTC
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHEA-2007-0256.html



Note You need to log in before you can comment on or make changes to this bug.